<?php

class HrbacitemController extends CController
{
	public $menu=array();
	public $breadcrumbs=array();
	
	/**
	 * @var string the default layout for the views. Defaults to 'column2', meaning
	 * using two-column layout. See 'protected/views/layouts/column2.php'.
	 */
	public $layout='application.views.layouts.column2';
//	public function beforeAction($action) 
//	{
//		$this->layout = Yii::app()->controller->module->layout;
//		return true;
//	}
	
	/**
	 * @var CActiveRecord the currently loaded data model instance.
	 */
	private $_model;

	/**
	 * @return array action filters
	 */
	public function filters()
	{
		return array();
	}

	/**
	 * Specifies the access control rules.
	 * This method is used by the 'accessControl' filter.
	 * @return array access control rules
	 */
	public function accessRules()
	{
		return array();
	}

	/**
	 * Displays a particular model.
	 */
	public function actionView()
	{
		$this->render('view',array(
			'model'=>$this->loadModel(),
		));
	}

	/**
	 * Creates a new model.
	 * If creation is successful, the browser will be redirected to the 'view' page.
	 */
	public function actionCreate()
	{
		$model=new HrbacItemModel;

		// Uncomment the following line if AJAX validation is needed
		// $this->performAjaxValidation($model);

		if(isset($_POST['HrbacItemModel']))
		{
			$model->attributes=$_POST['HrbacItemModel'];
			if($model->save())
				$this->redirect(array('view','id'=>$model->auth_id));
		}

		$this->render('create',array(
			'model'=>$model,
		));
	}

	/**
	 * Updates a particular model.
	 * If update is successful, the browser will be redirected to the 'view' page.
	 */
	public function actionUpdate()
	{
		$model=$this->loadModel();

		// Uncomment the following line if AJAX validation is needed
		// $this->performAjaxValidation($model);

		if(isset($_POST['HrbacItemModel']))
		{
			$model->attributes=$_POST['HrbacItemModel'];
			if($model->save())
				$this->redirect(array('view','id'=>$model->auth_id));
		}

		$this->render('update',array(
			'model'=>$model,
		));
	}

	/**
	 * Deletes a particular model.
	 * If deletion is successful, the browser will be redirected to the 'index' page.
	 */
	public function actionDelete()
	{
		if(Yii::app()->request->isPostRequest)
		{
			// we only allow deletion via POST request
			$this->loadModel()->delete();

			// if AJAX request (triggered by deletion via admin grid view), we should not redirect the browser
			if(!isset($_GET['ajax']))
				$this->redirect(array('index'));
		}
		else
			throw new CHttpException(400,'Invalid request. Please do not repeat this request again.');
	}

	/**
	 * Lists all models.
	 */
	public function actionIndex()
	{
		$dataProvider=new CActiveDataProvider('HrbacItemModel', array('sort'=> array('defaultOrder'=>'type DESC')));
		$this->render('index',array(
			'dataProvider'=>$dataProvider,
		));
	}

	public function actionInclude()
	{
		$item = $this->loadModel();
		if( Yii::app()->request->isPostRequest )
		{
			$item->replaceChildren(isset($_POST['include_ids']) ? $_POST['include_ids'] : array(), $_POST['cond']  );
		}
		$this->render('include',array(
			'model'=>$item,
		));
		
	}

	/**
	 * Manages all models.
	 */
	public function actionAdmin()
	{
		$model=new HrbacItemModel('search');
		if(isset($_GET['HrbacItemModel']))
			$model->attributes=$_GET['HrbacItemModel'];

		$this->render('admin',array(
			'model'=>$model,
		));
	}

	/**
	 * Returns the data model based on the primary key given in the GET variable.
	 * If the data model is not found, an HTTP exception will be raised.
	 */
	public function loadModel()
	{
		if($this->_model===null)
		{
			if(isset($_GET['id']))
				$this->_model=HrbacItemModel::model()->findbyPk($_GET['id']);
			if($this->_model===null)
				throw new CHttpException(404,'The requested page does not exist.');
		}
		return $this->_model;
	}

	/**
	 * Performs the AJAX validation.
	 * @param CModel the model to be validated
	 */
	protected function performAjaxValidation($model)
	{
		if(isset($_POST['ajax']) && $_POST['ajax']==='um-auth-item-model-form')
		{
			echo CActiveForm::validate($model);
			Yii::app()->end();
		}
	}
}
